package visitor;


import datapackage.*;
import mainpackage.*;
import syntaxtree.*;
import java.util.ArrayList;
import java.util.List;


public class MemberVisitor extends GJDepthFirst<String, MJClass>
{  
    private Function currentFunction;
    
    @Override
    public String visit(MainClass n, MJClass argu) throws Exception
    {
        Main.mainClass.getFunctions().put("main", new Function("main", "void"));

        n.f0.accept(this, argu);
        n.f1.accept(this, argu);
        n.f2.accept(this, argu);
        n.f3.accept(this, argu);
        n.f4.accept(this, argu);
        n.f5.accept(this, argu);
        n.f6.accept(this, argu);
        n.f7.accept(this, argu);
        n.f8.accept(this, argu);
        n.f9.accept(this, argu);
        n.f10.accept(this, argu);

        n.f11.accept(this, argu);
        Main.mainClass.getFunctions().get("main").getArguments()
                .put(n.f11.f0.tokenImage, new Variable(n.f11.f0.tokenImage, "string"));       

        n.f12.accept(this, argu);
        n.f13.accept(this, argu);
        n.f14.accept(this, argu);
        n.f15.accept(this, argu);
        n.f16.accept(this, argu);
        n.f17.accept(this, argu);

        return null;
    }

    @Override
    public String visit(ClassDeclaration n, MJClass argu) throws Exception
    {
        n.f0.accept(this, argu);
        n.f1.accept(this, argu);
        n.f2.accept(this, argu);                
               
        n.f3.accept(this, Main.programClasses.get(n.f1.f0.tokenImage));        
        
        n.f4.accept(this, Main.programClasses.get(n.f1.f0.tokenImage));       
        
        n.f5.accept(this, argu);
        
        return null;
    }
    
    @Override
    public String visit(ClassExtendsDeclaration n, MJClass argu) throws Exception
    {
        n.f0.accept(this, argu);
        n.f1.accept(this, argu);
        n.f2.accept(this, argu);
        n.f3.accept(this, argu);
        n.f4.accept(this, argu);
        
        n.f5.accept(this, Main.programClasses.get(n.f1.f0.tokenImage));         
        
        n.f6.accept(this, Main.programClasses.get(n.f1.f0.tokenImage));           
        
        n.f7.accept(this, argu);
        
        return null;
    }    
    
    @Override
    public String visit(VarDeclaration n, MJClass argu) throws Exception
    {                        
        String type = n.f0.accept(this, argu);        
        n.f1.accept(this, argu);
        n.f2.accept(this, argu);
         
        if(argu != null)
        {
            //If another member exists with the same name or the type isn't correct
            if(argu.getVariables().containsKey(n.f1.f0.tokenImage))
            { 
                System.err.println("Another variable exists with the same name!");
                throw new TypeCheckingError();
            }
            else if(!type.equals("array") && !type.equals("int") && !type.equals("boolean") 
                    && !Main.programClasses.containsKey(type) && !Main.mainClass.getIdentifier().equals(type))
            {
                System.err.println("The type of the variable doesn't exist!");
                throw new TypeCheckingError();                
            }
            argu.getVariables().put(n.f1.f0.tokenImage, new Variable(n.f1.f0.tokenImage, type));
        }
  
        return null;        
    }   
    
    @Override
    public String visit(MethodDeclaration n, MJClass argu) throws Exception
    {
        n.f0.accept(this, argu);
        String type = n.f1.accept(this, argu);
        n.f2.accept(this, argu);
        
        if(argu != null)
        {
            //If another function exists with the same name or the type isn't correct
            if(argu.getFunctions().containsKey(n.f2.f0.tokenImage))
            {   
                System.err.println("Another function exists with the same name!");
                throw new TypeCheckingError();
            }            
            else if(!type.equals("array") && !type.equals("int") && !type.equals("boolean") 
                    && !Main.programClasses.containsKey(type) && !Main.mainClass.getIdentifier().equals(type))
            {
                System.err.println("The type of the function isn't correct!");
                throw new TypeCheckingError();                
            }
            else if(argu.getExtendsClass() != null
                    && !Main.mainClass.getIdentifier().equals(argu.getExtendsClass()))
            {
                //If the extended class has a function with the same identifier
                if(Main.programClasses.get(argu.getExtendsClass()).getFunctions().containsKey(n.f2.f0.tokenImage))
                {
                    //but the the type is different
                    if(!Main.programClasses.get(argu.getExtendsClass()).
                        getFunctions().get(n.f2.f0.tokenImage).getType().equals(type))
                    {
                        System.err.println("The type of the extended function isn't the same!");                        
                        throw new TypeCheckingError();                        
                    }
                    
                }
            }
            
            argu.getFunctions().put(n.f2.f0.tokenImage, new Function(n.f2.f0.tokenImage, type));
        }        
        
        n.f3.accept(this, null);
        
        currentFunction = argu.getFunctions().get(n.f2.f0.tokenImage);
        
        n.f4.accept(this, argu);         
        
        n.f5.accept(this, null);
        n.f6.accept(this, null);
        n.f7.accept(this, null);
        n.f8.accept(this, null);
        n.f9.accept(this, null);
        n.f10.accept(this, null);
        n.f11.accept(this, null);
        n.f12.accept(this, null);

        return null;
    }  
    
    @Override
    public String visit(FormalParameterList n, MJClass argu) throws Exception
    {
        n.f0.accept(this, argu);
        n.f1.accept(this, argu);
  
        if (argu != null)
        {                        
            if (argu.getExtendsClass() != null
                && !Main.mainClass.getIdentifier().equals(argu.getExtendsClass()))
            {                      
                //If the extended class has a function with the same identifier
                if (Main.programClasses.get(argu.getExtendsClass())
                    .getFunctions().containsKey(currentFunction.getIdentifier()))
                {
                    //check if they don't have the same number of arguments
                    if (Main.programClasses.get(argu.getExtendsClass()).getFunctions()
                        .get(currentFunction.getIdentifier()).getArguments().size() != currentFunction.getArguments().size())
                    {
                        System.err.println("The number of the arguments aren't the same in extended function!");                        
                        throw new TypeCheckingError();
                    }
                    else
                    {
                        List<Variable> extList = new ArrayList();
                        extList.addAll(Main.programClasses.get(argu.getExtendsClass()).getFunctions()
                                .get(currentFunction.getIdentifier()).getArguments().values());

                        List<Variable> curList = new ArrayList();
                        curList.addAll(currentFunction.getArguments().values());

                        for (int i = 0; i < extList.size(); i++)
                        {
                            //check if they don't have exactly the same arguments
                            if (!extList.get(i).getType().equals(curList.get(i).getType()))
                            {
                                System.err.println("The arguments aren't the same in extended function!");                                
                                throw new TypeCheckingError();
                            }
                        }
                    }
                }
            }
        }          

        return null;
    }

    @Override
    public String visit(FormalParameter n, MJClass argu) throws Exception
    {
        String type = n.f0.accept(this, argu);
        n.f1.accept(this, argu);

        if (argu != null)
        {                             
            if (currentFunction.getArguments().containsKey(n.f1.f0.tokenImage) || argu.getVariables().containsKey(n.f1.f0.tokenImage))
            {
                System.err.println("A class variable or an argument exists with the same name!");
                throw new TypeCheckingError();
            }

            currentFunction.getArguments().put(n.f1.f0.tokenImage, new Variable(n.f1.f0.tokenImage, type));
        }

        return null;
    }
    
    @Override
    public String visit(ArrayType n, MJClass argu) throws Exception
    {
        super.visit(n, argu);
        
        return "array";
    }

    @Override
    public String visit(BooleanType n, MJClass argu) throws Exception
    {
        super.visit(n, argu);
        
        return "boolean";        
    }


    @Override
    public String visit(IntegerType n, MJClass argu) throws Exception
    {
        super.visit(n, argu);
        
        return "int";        
    }  
    
    @Override
   public String visit(Identifier n, MJClass argu) throws Exception
    {
        super.visit(n, argu);
        
        return n.f0.tokenImage;
    }   
    
}
